/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-26 17:13:51 UTC)
 * on 2013-09-04 at 18:59:48 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.adexchangeseller.model;

/**
 * Model definition for AdUnit.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Ad Exchange Seller API. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class AdUnit extends com.google.api.client.json.GenericJson {

  /**
   * Identity code of this ad unit, not necessarily unique across ad clients.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String code;

  /**
   * Unique identifier of this ad unit. This should be considered an opaque identifier; it is not
   * safe to rely on it being in any particular format.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * Kind of resource this is, in this case adexchangeseller#adUnit.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Name of this ad unit.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String name;

  /**
   * Status of this ad unit. Possible values are: NEW: Indicates that the ad unit was created within
   * the last seven days and does not yet have any activity associated with it.
   *
   * ACTIVE: Indicates that there has been activity on this ad unit in the last seven days.
   *
   * INACTIVE: Indicates that there has been no activity on this ad unit in the last seven days.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String status;

  /**
   * Identity code of this ad unit, not necessarily unique across ad clients.
   * @return value or {@code null} for none
   */
  public java.lang.String getCode() {
    return code;
  }

  /**
   * Identity code of this ad unit, not necessarily unique across ad clients.
   * @param code code or {@code null} for none
   */
  public AdUnit setCode(java.lang.String code) {
    this.code = code;
    return this;
  }

  /**
   * Unique identifier of this ad unit. This should be considered an opaque identifier; it is not
   * safe to rely on it being in any particular format.
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * Unique identifier of this ad unit. This should be considered an opaque identifier; it is not
   * safe to rely on it being in any particular format.
   * @param id id or {@code null} for none
   */
  public AdUnit setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * Kind of resource this is, in this case adexchangeseller#adUnit.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Kind of resource this is, in this case adexchangeseller#adUnit.
   * @param kind kind or {@code null} for none
   */
  public AdUnit setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Name of this ad unit.
   * @return value or {@code null} for none
   */
  public java.lang.String getName() {
    return name;
  }

  /**
   * Name of this ad unit.
   * @param name name or {@code null} for none
   */
  public AdUnit setName(java.lang.String name) {
    this.name = name;
    return this;
  }

  /**
   * Status of this ad unit. Possible values are: NEW: Indicates that the ad unit was created within
   * the last seven days and does not yet have any activity associated with it.
   *
   * ACTIVE: Indicates that there has been activity on this ad unit in the last seven days.
   *
   * INACTIVE: Indicates that there has been no activity on this ad unit in the last seven days.
   * @return value or {@code null} for none
   */
  public java.lang.String getStatus() {
    return status;
  }

  /**
   * Status of this ad unit. Possible values are: NEW: Indicates that the ad unit was created within
   * the last seven days and does not yet have any activity associated with it.
   *
   * ACTIVE: Indicates that there has been activity on this ad unit in the last seven days.
   *
   * INACTIVE: Indicates that there has been no activity on this ad unit in the last seven days.
   * @param status status or {@code null} for none
   */
  public AdUnit setStatus(java.lang.String status) {
    this.status = status;
    return this;
  }

  @Override
  public AdUnit set(String fieldName, Object value) {
    return (AdUnit) super.set(fieldName, value);
  }

  @Override
  public AdUnit clone() {
    return (AdUnit) super.clone();
  }

}
